<template>
  <div class="LaboratoryResearch">
    <div v-if="!load && !isSearch" class="wrap q-pa-md q-gutter-sm">
      <div class="flex items-center">
        <router-link :to="{name: pathName[0].path, params: {id: pathName[0].params.id}}">
          <q-btn flat icon="arrow_left" label="Назад" />
        </router-link>
        <Breadcrumbs :path="pathName"/>
      </div>
      <div v-for="(category, index) in LaboratoryResearch" :key="category.id_clr">
        <div class="expand p-2">
          <router-link
            :to="{name: 'ResearchOption', params: {id: category.id_lr}}"
            @click.prevent="save(category, category.name_lr, 'ResearchOption', {id: category.id_lr})"
            class="flex items-center"
          >
            <p class="count mr-4">{{category.id_lr}}</p>
            <img src="../assets/images/icons/lab.png" width="20" class="mr-4" alt="">
            <div class="flex flex-wrap max-w-[80%]">
              <p class="mr-3 truncate" :title="category.name_lr">{{category.name_lr}}</p>
              <p class="opacity-30 hover:opacity-90 truncate" :title="category.desc_lr">{{category.desc_lr}}</p>
            </div>
            <p class="text-red italic opacity-70 text-xs ml-auto">{{!category.total && 'Не заполнено' || ''}}</p>
            <img @click.prevent="edit(index)"
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-else-if="isSearch">
      <router-link to="/" @click.prevent="clearSearch">
        <q-btn flat icon="arrow_left" label="Назад" />
      </router-link>
      <div class="text-center my-6 text-xl opacity-70">Найдено исследований: <span class="text-white px-4 py-1 bg-black rounded-md text-ls">{{searchArr.length}}</span></div>
      <div v-for="(category, index) in searchArr" :key="category.id_clr">
        <div v-if="category" class="expand p-2">
          <router-link
            :to="{name: 'ResearchOption', params: {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr}}"
            @click.prevent="save(category, category.name_lr, 'ResearchOption', {id: category.id_lr})"
            class="flex"
          >
            <p class="count mr-4">{{index + 1}}</p>
            <img src="../assets/images/icons/lab.png" width="16" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_lr">{{category.name_lr}}</p>
            <img
              src="../assets/images/icons/pencil-outline.svg"
              width="16"
              class="ml-auto mr-4"
              alt=""
              v-if="1===2"
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-else class="flex justify-center mt-16">
      <LoadsSpinner v-if="load" large/>
    </div>
    <Modal v-if="modalEdit" @close="modalEdit = false" background-color="white" class="text-white">
      <template #body>
        <div class="min-w-lg">
          <div class="text-lg opacity-70 mb-4 text-black">Редактирование</div>
          <q-input autofocus v-model="editLaboratoryResearch.name_lr" label="Название"/>
          <q-input v-model="editLaboratoryResearch.full_name_lr" label="Полное название"/>
          <q-input v-model="editLaboratoryResearch.desc_lr" label="Описание"/>
          <div class="edit-modal-switch-wrap">
            <q-toggle v-model="editLaboratoryResearch.for_mens" :label="editLaboratoryResearch.for_mens && 'Подходит для мужчин' || 'Не подходит для мужчин'"/>
            <q-toggle v-model="editLaboratoryResearch.for_womens" :label="editLaboratoryResearch.for_womens && 'Подходит для женщин' || 'Не подходит для женщин'"/>
            <q-toggle v-model="editLaboratoryResearch.na" :label="editLaboratoryResearch.na && 'Исследование активно' || 'Исследование не активно'"/>
          </div>
          <div class="flex mt-4 justify-end">
            <q-btn color="red" label="Удалить" class="mr-2" />
            <q-btn color="primary" label="Применить" />
          </div>
        </div>
      </template>
    </Modal>
  </div>
</template>

<script>
import Modal from "../components/Modal.vue";
import LoadsSpinner from "../components/Loads-spinner.vue";
import {computed, onMounted, ref} from "vue";
import { useRoute, useRouter } from 'vue-router'
import axios from "axios";
import {useStore} from "vuex";
import Breadcrumbs from "../components/Breadcrumbs.vue";
export default {
  name: "LaboratoryResearch",
  components: {Breadcrumbs, LoadsSpinner, Modal},

  setup () {
    let store = useStore()
    let route = useRoute()
    let LaboratoryResearch = ref([])
    let editLaboratoryResearch = ref({})
    let load = ref(false)
    let modalEdit = ref(false)
    let pathName = computed(function () {
      return store.state.path
    });
    let isSearch = computed(function () {
      return store.state.isSearch
    });

    async function init () {
      load.value = true
      await axios.get('http://188.120.231.191:3000/lab_research?id_clr=eq.'+route.params.id)
        .then(res => {
          store.state.path[2] = {name: '', path: '', params: ''}
          LaboratoryResearch.value = res.data
          res.data.forEach(async (el, index) => {
            await axios.get(`http://188.120.231.191:3000/lab_research?id_lr=eq.${el.id_clr}&select=id_lr,name_lr,research_options(id_ro, desc_ro)`)
              .then(response => {
                LaboratoryResearch.value[index].total = response.data.length
              })
          })
          load.value = false
        })
    }
    function edit (index) {
      editLaboratoryResearch.value = LaboratoryResearch.value[index]
      modalEdit.value = true
    }
    function save (el, name, path, params) {
      if (!modalEdit.value) {
        localStorage.setItem('LaboratoryResearch', JSON.stringify(el))
        store.commit('SET_PATH', {name, index: 2, path, params})
        if (searchArr.value.length) {
          store.commit('SET_STATE_SEARCH')
        }
      }
    }
    function clearSearch () {
      store.commit('SEARCH_CLEAR')
    }

    let searchArr = computed(function () {
      return store.state.searchArray
    });
    onMounted(()=> {
      init()
    })
    return {
      router: useRouter(),
      pathName,
      searchArr,
      isSearch,
      LaboratoryResearch,
      editLaboratoryResearch,
      modalEdit,
      load,
      route,
      edit,
      clearSearch,
      save
    }
  }
}
</script>

<style scoped lang="scss">
.edit-modal-switch-wrap {
  color: black;
  display: grid;
  grid-template-columns: 1fr 1fr;
  margin-top: 20px;
}
</style>
